'use strict';

Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });

const snakeCase = require('../_chunk/snakeCase-BtVEeB.js');
const reverseString = require('../_chunk/reverseString-D-wK2p.js');

function startCase(str) {
    const words = snakeCase.words(str.trim());
    let result = '';
    for (let i = 0; i < words.length; i++) {
        const word = words[i];
        if (result) {
            result += ' ';
        }
        result += word[0].toUpperCase() + word.slice(1).toLowerCase();
    }
    return result;
}

exports.camelCase = snakeCase.camelCase;
exports.capitalize = snakeCase.capitalize;
exports.deburr = snakeCase.deburr;
exports.snakeCase = snakeCase.snakeCase;
exports.words = snakeCase.words;
exports.constantCase = reverseString.constantCase;
exports.escape = reverseString.escape;
exports.escapeRegExp = reverseString.escapeRegExp;
exports.kebabCase = reverseString.kebabCase;
exports.lowerCase = reverseString.lowerCase;
exports.lowerFirst = reverseString.lowerFirst;
exports.pad = reverseString.pad;
exports.pascalCase = reverseString.pascalCase;
exports.reverseString = reverseString.reverseString;
exports.trim = reverseString.trim;
exports.trimEnd = reverseString.trimEnd;
exports.trimStart = reverseString.trimStart;
exports.unescape = reverseString.unescape;
exports.upperCase = reverseString.upperCase;
exports.upperFirst = reverseString.upperFirst;
exports.startCase = startCase;
